--- old/usr/src/lib/libhotplug/common/libhotplug.c	2015-08-18 18:50:58.540771089 -0400
+++ new/usr/src/lib/libhotplug/common/libhotplug.c	2015-08-18 18:50:58.546317711 -0400
@@ -463,13 +463,12 @@
 		(void) strlcpy(connection, node->hp_name, MAXPATHLEN);
 
 	/* Trace back to the root node, accumulating components */
-	for (parent = node; parent != NULL; parent = parent->hp_parent) {
+	for (parent = node, root = parent; parent != NULL;
+	    root = parent, parent = parent->hp_parent) {
 		if (parent->hp_type == HP_NODE_DEVICE) {
 			(void) strlcat(components, "/", MAXPATHLEN);
 			(void) strlcat(components, parent->hp_name, MAXPATHLEN);
 		}
-		if (parent->hp_parent == NULL)
-			root = parent;
 	}
 
 	/* Ensure the snapshot actually contains a base path */
